(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/router'), require('ng2-bootstrap'), require('rxjs/add/operator/filter')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/router', 'ng2-bootstrap', 'rxjs/add/operator/filter'], factory) :
    (factory((global.ng = global.ng || {}, global.ng.CoreUIAngular = global.ng.CoreUIAngular || {}),global.ng.core,global.ng.common,global.ng.router,global.ng2Bootstrap,global.rxjs_add_operator_filter));
}(this, (function (exports,_angular_core,_angular_common,_angular_router,ng2Bootstrap,rxjs_add_operator_filter) { 'use strict';

var BreadcrumbsComponent = (function () {
    function BreadcrumbsComponent(router, route) {
        this.router = router;
        this.route = route;
    }
    BreadcrumbsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.router.events.filter(function (event) { return event instanceof _angular_router.NavigationEnd; }).subscribe(function () {
            _this.breadcrumbs = [];
            var currentRoute = _this.route.root, url = '';
            do {
                var childrenRoutes = currentRoute.children;
                currentRoute = null;
                childrenRoutes.forEach(function (route) {
                    if (route.outlet === 'primary') {
                        var routeSnapshot = route.snapshot;
                        url += '/' + routeSnapshot.url.map(function (segment) { return segment.path; }).join('/');
                        _this.breadcrumbs.push({
                            label: route.snapshot.data,
                            url: url
                        });
                        currentRoute = route;
                    }
                });
            } while (currentRoute);
        });
    };
    BreadcrumbsComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'coreui-breadcrumbs',
                    template: "\n    <template ngFor let-breadcrumb [ngForOf]=\"breadcrumbs\" let-last = last>\n        <li class=\"breadcrumb-item\" *ngIf=\"breadcrumb.label.title\" [ngClass]=\"{active: last}\">\n        <a *ngIf=\"!last\" [routerLink]=\"breadcrumb.url\">{{breadcrumb.label.title}}</a>\n        <span *ngIf=\"last\" [routerLink]=\"breadcrumb.url\">{{breadcrumb.label.title}}</span>\n    </template>\n    &nbsp;\n"
                },] },
    ];
    /** @nocollapse */
    BreadcrumbsComponent.ctorParameters = function () { return [
        { type: _angular_router.Router, },
        { type: _angular_router.ActivatedRoute, },
    ]; };
    return BreadcrumbsComponent;
}());

var FooterComponent = (function () {
    function FooterComponent() {
    }
    FooterComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'coreui-footer',
                    template: "\n    <footer class=\"footer\">\n        <span class=\"text-left\" [innerHtml]=\"config.left\"></span>\n        <span class=\"float-xs-right\" [innerHtml]=\"config.right\"></span>\n    </footer>\n  ",
                },] },
    ];
    /** @nocollapse */
    FooterComponent.ctorParameters = function () { return []; };
    FooterComponent.propDecorators = {
        'config': [{ type: _angular_core.Input },],
    };
    return FooterComponent;
}());

var HeaderComponent = (function () {
    function HeaderComponent() {
    }
    HeaderComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'coreui-header',
                    template: "\n    <header class=\"navbar\">\n      <div class=\"container-fluid\">\n        <button class=\"navbar-toggler hidden-lg-up\" type=\"button\" mobile-nav-toggle>&#9776;</button>\n        <a class=\"navbar-brand\" href=\"#\"></a>\n    \n        <ul class=\"nav navbar-nav hidden-md-down\">\n          <li class=\"nav-item\">\n            <a class=\"nav-link navbar-toggler sidebar-toggle\" href=\"#\">&#9776;</a>\n          </li>\n          <li class=\"nav-item px-1\" *ngFor=\"let nav of config.nav\">\n            <i class=\"{{nav.icon}}\"></i>\n            <a class=\"nav-link\"\n               routerLinkActive=\"active\"\n               [routerLinkActiveOptions]=\"{exact: true}\"\n               [routerLink]=\"nav.link\">{{nav.label}}</a>\n          </li>\n        </ul>\n        \n        <ul class=\"nav navbar-nav float-xs-right hidden-md-down\">\n          <li class=\"nav-item dropdown px-1\" dropdown>\n            <a class=\"nav-link dropdown-toggle\"\n               data-toggle=\"dropdown\" href=\"#\" role=\"button\" aria-haspopup=\"true\" aria-expanded=\"false\" dropdownToggle>\n              \n              <span class=\"hidden-md-down\">admin</span>\n            </a>\n            <div class=\"dropdown-menu dropdown-menu-right\" dropdownMenu aria-labelledby=\"simple-dropdown\">\n              <div class=\"dropdown-header text-xs-center\">\n                <strong>Settings</strong>\n              </div>\n              <a class=\"dropdown-item\" href=\"#\"><i class=\"fa fa-user\"></i> Profile</a>\n              <div class=\"divider\"></div>\n              <a class=\"dropdown-item\" href=\"#\"><i class=\"fa fa-lock\"></i> Logout</a>\n            </div>\n          </li>\n          <li class=\"nav-item\" *ngIf=\"config.aside\">\n            <a class=\"nav-link navbar-toggler aside-toggle\" href=\"#\">&#9776;</a>\n          </li>\n        </ul>\n      </div>\n    </header>\n",
                },] },
    ];
    /** @nocollapse */
    HeaderComponent.ctorParameters = function () { return []; };
    HeaderComponent.propDecorators = {
        'config': [{ type: _angular_core.Input },],
    };
    return HeaderComponent;
}());

var LayoutComponent = (function () {
    function LayoutComponent() {
    }
    LayoutComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'coreui-layout',
                    template: "\n    <coreui-header  [config]=\"config.header\">   </coreui-header>\n    <coreui-sidebar [config]=\"config.sidebar\">  </coreui-sidebar>\n    <coreui-main    [config]=\"config.main\">\n      <ng-content></ng-content>\n    </coreui-main>\n    <coreui-footer  [config]=\"config.footer\">   </coreui-footer>\n",
                    styles: []
                },] },
    ];
    /** @nocollapse */
    LayoutComponent.ctorParameters = function () { return []; };
    LayoutComponent.propDecorators = {
        'config': [{ type: _angular_core.Input },],
    };
    return LayoutComponent;
}());

var MainComponent = (function () {
    function MainComponent() {
    }
    MainComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'coreui-main',
                    template: "\n  <!-- Main content -->\n  <main class=\"main\">\n  \n    <!-- Breadcrumb -->\n    <ol class=\"breadcrumb\" *ngIf=\"config.breadcrumbs\">\n      <coreui-breadcrumbs></coreui-breadcrumbs>\n  \n      <!-- Breadcrumb Menu-->\n      <li class=\"breadcrumb-menu\" *ngIf=\"config.nav\">\n        <div class=\"btn-group\" role=\"group\" aria-label=\"Button group with nested dropdown\">\n          <a *ngFor=\"let nav of config.nav\" class=\"btn btn-secondary\" [routerLinkActiveOptions]=\"{exact: true}\"\n            routerLinkActive=\"active\" [routerLink]=\"nav.link\">\n            <i *ngIf=\"nav.icon\" class=\"{{nav.icon}}\"></i>\n            {{nav.label}}\n          </a>\n        </div>\n      </li>\n    </ol>\n  \n    <div class=\"container-fluid\">\n      <ng-content></ng-content>\n    </div>\n\n  </main>\n  <aside class=\"aside-menu\">\n    \n  </aside>\n  ",
                },] },
    ];
    /** @nocollapse */
    MainComponent.ctorParameters = function () { return []; };
    MainComponent.propDecorators = {
        'config': [{ type: _angular_core.Input },],
    };
    return MainComponent;
}());

var SidebarComponent = (function () {
    function SidebarComponent() {
    }
    SidebarComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'coreui-sidebar',
                    template: "\n  <div class=\"sidebar\">\n    <nav class=\"sidebar-nav\">\n      <ul class=\"nav\">\n        <li *ngFor=\"let nav of config.nav\" class=\"nav-{{nav.type}}\">\n          <a class=\"nav-link\" routerLinkActive=\"active\" [routerLink]=nav.link [routerLinkActiveOptions]=\"{exact: true}\">\n            <i *ngIf=\"nav.icon\" class=\"{{nav.icon}}\"></i>\n            {{nav.label}}\n          </a>\n        </li>\n      </ul>\n    </nav>\n  </div>\n  ",
                    styles: []
                },] },
    ];
    /** @nocollapse */
    SidebarComponent.ctorParameters = function () { return []; };
    SidebarComponent.propDecorators = {
        'config': [{ type: _angular_core.Input },],
    };
    return SidebarComponent;
}());

/**
 * Allows the aside to be toggled via click.
 */
var AsideToggleDirective = (function () {
    function AsideToggleDirective() {
    }
    AsideToggleDirective.prototype.toggleOpen = function ($event) {
        $event.preventDefault();
        document.querySelector('body').classList.toggle('aside-menu-open');
    };
    AsideToggleDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: '.aside-toggle',
                },] },
    ];
    /** @nocollapse */
    AsideToggleDirective.ctorParameters = function () { return []; };
    AsideToggleDirective.propDecorators = {
        'toggleOpen': [{ type: _angular_core.HostListener, args: ['click', ['$event'],] },],
    };
    return AsideToggleDirective;
}());

var NavDropdownDirective = (function () {
    function NavDropdownDirective() {
        this._open = false;
    }
    /**
     * Checks if the dropdown menu is open or not.
     */
    NavDropdownDirective.prototype.isOpen = function () {
        return this._open;
    };
    /**
     * Opens the dropdown menu.
     */
    NavDropdownDirective.prototype.open = function () {
        this._open = true;
    };
    /**
     * Closes the dropdown menu .
     */
    NavDropdownDirective.prototype.close = function () {
        this._open = false;
    };
    /**
     * Toggles the dropdown menu.
     */
    NavDropdownDirective.prototype.toggle = function () {
        if (this.isOpen()) {
            this.close();
        }
        else {
            this.open();
        }
    };
    NavDropdownDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: '.nav-dropdown',
                    host: {
                        '[class.open]': '_open',
                    }
                },] },
    ];
    /** @nocollapse */
    NavDropdownDirective.ctorParameters = function () { return []; };
    return NavDropdownDirective;
}());
/**
 * Allows the dropdown to be toggled via click.
 */
var NavDropdownToggleDirective = (function () {
    function NavDropdownToggleDirective(dropdown) {
        this.dropdown = dropdown;
    }
    NavDropdownToggleDirective.prototype.toggleOpen = function ($event) {
        $event.preventDefault();
        this.dropdown.toggle();
    };
    NavDropdownToggleDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: '.nav-dropdown-toggle',
                },] },
    ];
    /** @nocollapse */
    NavDropdownToggleDirective.ctorParameters = function () { return [
        { type: NavDropdownDirective, },
    ]; };
    NavDropdownToggleDirective.propDecorators = {
        'toggleOpen': [{ type: _angular_core.HostListener, args: ['click', ['$event'],] },],
    };
    return NavDropdownToggleDirective;
}());

/**
 * Allows the sidebar to be toggled via click.
 */
var SidebarToggleDirective = (function () {
    function SidebarToggleDirective() {
    }
    // Check if element has class
    SidebarToggleDirective.hasClass = function (target, elementClassName) {
        return new RegExp('(\\s|^)' + elementClassName + '(\\s|$)').test(target.className);
    };
    // Toggle element class
    SidebarToggleDirective.toggleClass = function (elem, elementClassName) {
        var newClass = ' ' + elem.className.replace(/[\t\r\n]/g, ' ') + ' ';
        if (SidebarToggleDirective.hasClass(elem, elementClassName)) {
            while (newClass.indexOf(' ' + elementClassName + ' ') >= 0) {
                newClass = newClass.replace(' ' + elementClassName + ' ', ' ');
            }
            elem.className = newClass.replace(/^\s+|\s+$/g, '');
        }
        else {
            elem.className += ' ' + elementClassName;
        }
    };
    SidebarToggleDirective.prototype.toggleOpen = function ($event) {
        $event.preventDefault();
        var bodyClass = localStorage.getItem('body-class');
        if (SidebarToggleDirective.hasClass(document.querySelector('body'), 'sidebar-off-canvas')) {
            SidebarToggleDirective.toggleClass(document.querySelector('body'), 'sidebar-opened');
            SidebarToggleDirective.toggleClass(document.querySelector('html'), 'sidebar-opened');
        }
        else if (SidebarToggleDirective.hasClass(document.querySelector('body'), 'sidebar-nav') || bodyClass === 'sidebar-nav') {
            SidebarToggleDirective.toggleClass(document.querySelector('body'), 'sidebar-nav');
            localStorage.setItem('body-class', 'sidebar-nav');
            if (bodyClass === 'sidebar-nav') {
                localStorage.clear();
            }
        }
    };
    SidebarToggleDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: '.sidebar-toggle',
                },] },
    ];
    /** @nocollapse */
    SidebarToggleDirective.ctorParameters = function () { return []; };
    SidebarToggleDirective.propDecorators = {
        'toggleOpen': [{ type: _angular_core.HostListener, args: ['click', ['$event'],] },],
    };
    return SidebarToggleDirective;
}());
var MobileSidebarToggleDirective = (function () {
    function MobileSidebarToggleDirective() {
    }
    // Check if element has class
    MobileSidebarToggleDirective.hasClass = function (target, elementClassName) {
        return new RegExp('(\\s|^)' + elementClassName + '(\\s|$)').test(target.className);
    };
    // Toggle element class
    MobileSidebarToggleDirective.toggleClass = function (elem, elementClassName) {
        var newClass = ' ' + elem.className.replace(/[\t\r\n]/g, ' ') + ' ';
        if (MobileSidebarToggleDirective.hasClass(elem, elementClassName)) {
            while (newClass.indexOf(' ' + elementClassName + ' ') >= 0) {
                newClass = newClass.replace(' ' + elementClassName + ' ', ' ');
            }
            elem.className = newClass.replace(/^\s+|\s+$/g, '');
        }
        else {
            elem.className += ' ' + elementClassName;
        }
    };
    MobileSidebarToggleDirective.prototype.toggleOpen = function ($event) {
        $event.preventDefault();
        MobileSidebarToggleDirective.toggleClass(document.querySelector('body'), 'mobile-open');
    };
    MobileSidebarToggleDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: '[mobile-nav-toggle]',
                },] },
    ];
    /** @nocollapse */
    MobileSidebarToggleDirective.ctorParameters = function () { return []; };
    MobileSidebarToggleDirective.propDecorators = {
        'toggleOpen': [{ type: _angular_core.HostListener, args: ['click', ['$event'],] },],
    };
    return MobileSidebarToggleDirective;
}());
/**
 * Allows the off-canvas sidebar to be closed via click.
 */
var SidebarOffCanvasCloseDirective = (function () {
    function SidebarOffCanvasCloseDirective() {
    }
    // Check if element has class
    SidebarOffCanvasCloseDirective.hasClass = function (target, elementClassName) {
        return new RegExp('(\\s|^)' + elementClassName + '(\\s|$)').test(target.className);
    };
    // Toggle element class
    SidebarOffCanvasCloseDirective.toggleClass = function (elem, elementClassName) {
        var newClass = ' ' + elem.className.replace(/[\t\r\n]/g, ' ') + ' ';
        if (SidebarOffCanvasCloseDirective.hasClass(elem, elementClassName)) {
            while (newClass.indexOf(' ' + elementClassName + ' ') >= 0) {
                newClass = newClass.replace(' ' + elementClassName + ' ', ' ');
            }
            elem.className = newClass.replace(/^\s+|\s+$/g, '');
        }
        else {
            elem.className += ' ' + elementClassName;
        }
    };
    SidebarOffCanvasCloseDirective.prototype.toggleOpen = function ($event) {
        $event.preventDefault();
        if (SidebarOffCanvasCloseDirective.hasClass(document.querySelector('body'), 'sidebar-off-canvas')) {
            SidebarOffCanvasCloseDirective.toggleClass(document.querySelector('body'), 'sidebar-opened');
        }
    };
    SidebarOffCanvasCloseDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: '.sidebar-close',
                },] },
    ];
    /** @nocollapse */
    SidebarOffCanvasCloseDirective.ctorParameters = function () { return []; };
    SidebarOffCanvasCloseDirective.propDecorators = {
        'toggleOpen': [{ type: _angular_core.HostListener, args: ['click', ['$event'],] },],
    };
    return SidebarOffCanvasCloseDirective;
}());

var components = [
    BreadcrumbsComponent,
    FooterComponent,
    HeaderComponent,
    LayoutComponent,
    MainComponent,
    SidebarComponent,
];
var directives = [
    AsideToggleDirective,
    MobileSidebarToggleDirective,
    NavDropdownDirective,
    NavDropdownToggleDirective,
    SidebarToggleDirective,
    SidebarOffCanvasCloseDirective,
];
var CoreUIModule = (function () {
    function CoreUIModule() {
    }
    CoreUIModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    imports: [
                        _angular_common.CommonModule,
                        _angular_router.RouterModule,
                        ng2Bootstrap.DropdownModule,
                    ],
                    declarations: components.concat(directives),
                    exports: components.concat(directives)
                },] },
    ];
    /** @nocollapse */
    CoreUIModule.ctorParameters = function () { return []; };
    return CoreUIModule;
}());

exports.components = components;
exports.directives = directives;
exports.CoreUIModule = CoreUIModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
